stages:          # List of stages for jobs, and their order of execution
  - test
  - deploy

default:
  interruptible: false
  image: ubuntu:20.04

variables:
  MAINTAIN_MODE: 'NORMAL_MODE'

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Running unit tests... This will take about 60 seconds."

deploy-job-00-always:
  stage: deploy
  script:
    - echo "MAINTAIN_MODE variable is $MAINTAIN_MODE"
    - echo "Deploying application..."

deploy-job-01-is-maintain-mode:
  stage: deploy
  rules:
    - if: $MAINTAIN_MODE == 'MAINTAIN_MODE'
  script:
    - echo "MAINTAIN_MODE variable is $MAINTAIN_MODE"
    - echo "is maintain mode"
    - echo "Deploying application with maintain mode..."

deploy-job-02-is-not-maintain-mode:
  stage: deploy
  rules:
    - if: $MAINTAIN_MODE != 'MAINTAIN_MODE'
  script:
    - echo "MAINTAIN_MODE variable is $MAINTAIN_MODE"
    - echo "is not maintain mode"
    - echo "Deploying application..."
